LMS.Web/ViewModels/BookItemViewModel.cs
using LMS.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace LMS.WEB.ViewModels
{
    public class BookItemViewModel
    {

        public int RackNumber { get; set; }
        public int? BookId { get; set; }
    }
}

LMS.Web/Controllers/BookItemsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using LMS.Data;
using LMS.Data.Models;
using LMS.Services.Contracts;
using LMS.WEB.ViewModels;

namespace LMS.WEB.Controllers
{
    public class BookItemsController : Controller
    {
        private readonly LMSContext _context;
        private IBookItemManager _bookItemManager;
        private IBookManager _bookManager;

        public BookItemsController(LMSContext context, IBookItemManager bookItemManager, IBookManager bookManager)
        {
            _context = context;
            _bookItemManager = bookItemManager;
            _bookManager = bookManager;
        }

        // GET: BookItems
        public async Task<IActionResult> Index()
        {
            var lMSContext = _context.BookItems.Include(b => b.Book);
            return View(await lMSContext.ToListAsync());
        }

        // GET: BookItems/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var bookItem = await _context.BookItems
                .Include(b => b.Book)
                .FirstOrDefaultAsync(m => m.BookItemId == id);
            if (bookItem == null)
            {
                return NotFound();
            }

            return View(bookItem);
        }
        [HttpGet]
        public IActionResult Create(int? id)
        {
            var bookItemViewModel = new BookItemViewModel() { BookId = id };
            return View(bookItemViewModel);
        }
        // GET: BookItems/Create
        [HttpPost]
        public async Task<IActionResult> Creates(int rackNumber, int? bookId)
        {
            await this._bookItemManager.AddBookItem(bookId, rackNumber);
            return Redirect(nameof(Index));
        }

        // POST: BookItems/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        //[HttpPost]
        //[ValidateAntiForgeryToken]
        //public async Task<IActionResult> Create([Bind("BookItemId,ReferenceOnly,BookStatus,RackNumber,BookID,IsDeleted")] BookItem bookItem)
        //{
        //    if (ModelState.IsValid)
        //    {
        //        _context.Add(bookItem);
        //        await _context.SaveChangesAsync();
        //        return RedirectToAction(nameof(Index));
        //    }
        //    ViewData["BookID"] = new SelectList(_context.Books, "BookId", "Title", bookItem.BookID);
        //    return View(bookItem);
        //}

        // GET: BookItems/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var bookItem = await _context.BookItems.FindAsync(id);
            if (bookItem == null)
            {
                return NotFound();
            }
            ViewData["BookID"] = new SelectList(_context.Books, "BookId", "Title", bookItem.BookID);
            return View(bookItem);
        }

        // POST: BookItems/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("BookItemId,ReferenceOnly,BookStatus,RackNumber,BookID,IsDeleted")] BookItem bookItem)
        {
            if (id != bookItem.BookItemId)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(bookItem);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!BookItemExists(bookItem.BookItemId))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            ViewData["BookID"] = new SelectList(_context.Books, "BookId", "Title", bookItem.BookID);
            return View(bookItem);
        }

        // GET: BookItems/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var bookItem = await _context.BookItems
                .Include(b => b.Book)
                .FirstOrDefaultAsync(m => m.BookItemId == id);
            if (bookItem == null)
            {
                return NotFound();
            }

            return View(bookItem);
        }

        // POST: BookItems/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var bookItem = await _context.BookItems.FindAsync(id);
            _context.BookItems.Remove(bookItem);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool BookItemExists(int id)
        {
            return _context.BookItems.Any(e => e.BookItemId == id);
        }
    }
}

LMS.Web/Views/BookItems/Create.cshtml
@model BookItemViewModel
@{
    ViewData["Title"] = "Create";
}
<br />
<br />
<br />
<h1>Add Copy of</h1>

<h4>Book</h4>
<hr />
<div class="row">
    
    <div class="col-md-4">
        <form asp-controller="BookItems" asp-action="Creates" method="post">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="RackNumber" class="control-label"></label>
                <input asp-for="RackNumber" class="form-control" />
                <span asp-validation-for="RackNumber" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="BookId" class="control-label"></label>
                <input asp-for="BookId" class="form-control" asp-route-id="@Model.BookId" />
                <span asp-validation-for="BookId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Creates" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

LMS.Web/Views/BookItems/Delete.cshtml
@model LMS.Data.Models.BookItem

@{
    ViewData["Title"] = "Delete";
}

<h1>Delete</h1>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>BookItem</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.ReferenceOnly)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.ReferenceOnly)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.BookStatus)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.BookStatus)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.RackNumber)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.RackNumber)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Book)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Book.Title)
        </dd class>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.IsDeleted)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.IsDeleted)
        </dd>
    </dl>
    
    <form asp-action="Delete">
        <input type="hidden" asp-for="BookItemId" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>

LMS.Web/Views/BookItems/Details.cshtml
@model LMS.Data.Models.BookItem

@{
    ViewData["Title"] = "Details";
}

<h1>Details</h1>

<div>
    <h4>BookItem</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.ReferenceOnly)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.ReferenceOnly)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.BookStatus)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.BookStatus)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.RackNumber)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.RackNumber)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Book)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Book.Title)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.IsDeleted)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.IsDeleted)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.BookItemId">Edit</a> |
    <a asp-action="Index">Back to List</a>
</div>

LMS.Web/Views/BookItems/Edit.cshtml
@model LMS.Data.Models.BookItem

@{
    ViewData["Title"] = "Edit";
}

<h1>Edit</h1>

<h4>BookItem</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="BookItemId" />
            <div class="form-group form-check">
                <label class="form-check-label">
                    <input class="form-check-input" asp-for="ReferenceOnly" /> @Html.DisplayNameFor(model => model.ReferenceOnly)
                </label>
            </div>
            <div class="form-group">
                <label asp-for="BookStatus" class="control-label"></label>
                <select asp-for="BookStatus" class="form-control"></select>
                <span asp-validation-for="BookStatus" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="RackNumber" class="control-label"></label>
                <input asp-for="RackNumber" class="form-control" />
                <span asp-validation-for="RackNumber" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="BookID" class="control-label"></label>
                <select asp-for="BookID" class="form-control" asp-items="ViewBag.BookID"></select>
                <span asp-validation-for="BookID" class="text-danger"></span>
            </div>
            <div class="form-group form-check">
                <label class="form-check-label">
                    <input class="form-check-input" asp-for="IsDeleted" /> @Html.DisplayNameFor(model => model.IsDeleted)
                </label>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

LMS.Web/Views/BookItems/Index.cshtml
@model IEnumerable<LMS.Data.Models.BookItem>

@{
    ViewData["Title"] = "Index";
}
<br />
<br />
<br />
<h1>Index</h1>

<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.ReferenceOnly)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.BookStatus)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.RackNumber)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Book)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.IsDeleted)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.ReferenceOnly)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.BookStatus)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.RackNumber)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Book.Title)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.IsDeleted)
            </td>
            <td>
                <a asp-action="Edit" asp-route-id="@item.BookItemId">Edit</a> |
                <a asp-action="Details" asp-route-id="@item.BookItemId">Details</a> |
                <a asp-action="Delete" asp-route-id="@item.BookItemId">Delete</a>
            </td>
        </tr>
}
    </tbody>
</table>